#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

public Plugin:myinfo = 
{
	name	= "Mortal Game",
	author	= "wS (World-Source.Ru)",
	version = "1.0"
};

#define PROP_MODEL "models/props/cs_militia/crate_extrasmallmill.mdl"

new Float:g_fPos[3][3];
new g_Unlocked;
new Handle:g_hRefs_Array;
new Float:g_fLastAttackTime[MAXPLAYERS + 1];
new Handle:g_hTimer = INVALID_HANDLE;

public OnPluginStart()
{
	g_fPos[0][0]  = 12345.0;
	g_hRefs_Array = CreateArray(1);

	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
}

public OnClientPutInServer(client)
{
	g_fLastAttackTime[client] = 0.0;
}

public OnMapEnd()
{
	g_fPos[0][0] = 12345.0;
}

public OnMapStart()
{
	g_fPos[0][0] = 12345.0;
	decl String:info[250]; GetCurrentMap(info, 250);
	Format(info, 250, "cfg/mortal_game/%s.txt", info);
	new Handle:kv = CreateKeyValues("wS");
	if (FileToKeyValues(kv, info))
	{
		KvGetVector(kv, "pos1", g_fPos[0]);
		KvGetVector(kv, "pos2", g_fPos[1]);
		KvGetVector(kv, "pos3", g_fPos[2]);
		PrecacheModel(PROP_MODEL, true);
		ServerCommand("mp_restartgame 1");
	}
	CloseHandle(kv);
}

public round_start(Handle:event, const String:name[], bool:silent)
{
	if (g_hTimer != INVALID_HANDLE)
	{
		KillTimer(g_hTimer);
		g_hTimer = INVALID_HANDLE;
	}

	if (g_fPos[0][0] != 12345.0)
		wS_RestartGame();
}

wS_RestartGame()
{
	g_Unlocked = 0;
	ClearArray(g_hRefs_Array);
	new Handle:Ar = CreateArray(1);
	PushArrayCell(Ar, 1);
	PushArrayCell(Ar, 2);
	PushArrayCell(Ar, 3);
	SortADTArray(Ar, Sort_Random, Sort_Integer);
	for (new i = 0; i < 3; i++) wS_CreateProp(g_fPos[i], GetArrayCell(Ar, i));
	CloseHandle(Ar);
}

wS_CreateProp(const Float:origin[3], num)
{
	decl entity;
	if ((entity = CreateEntityByName("prop_dynamic")) > 0)
	{
		decl String:name[10];
		Format(name, 10, "%dmgame", num);
		DispatchKeyValue(entity, "targetname", name);
		PushArrayCell(g_hRefs_Array, EntIndexToEntRef(entity));
		DispatchKeyValueVector(entity, "origin", origin);
		DispatchKeyValue(entity, "model", PROP_MODEL);
		DispatchKeyValue(entity, "solid", "6");
		DispatchSpawn(entity);
		wS_SetColor(entity, 255, 0, 0, 255);
		SetEntityRenderFx(entity, RENDERFX_FLICKER_SLOW);
		HookSingleEntityOutput(entity, "OnTakeDamage", OnTakeDamage, false);
	}
	else
		LogError("Can't create prop_dynamic");
}

public OnTakeDamage(const String:output[], entity, activator, Float:delay)
{
	if (g_Unlocked < 3 && activator > 0 && activator <= MaxClients && IsClientInGame(activator) && IsPlayerAlive(activator))
	{
		//////

		// событие часто срабатывает 2 раза подряд (wtf)
		// ну и чтобы взрыв гранаты не мог 'ранить' сразу 3 пропа

		new Float:CurTime = GetGameTime();
		if ((CurTime - g_fLastAttackTime[activator]) < 0.1) return;
		g_fLastAttackTime[activator] = CurTime;

		//////

		decl String:name[3];
		GetEntPropString(entity, Prop_Data, "m_iName", name, 3);
		name[1] = '\0';
		if (StringToInt(name) == (g_Unlocked + 1))
		{
			UnhookSingleEntityOutput(entity, "OnTakeDamage", OnTakeDamage);
			wS_SetColor(entity, 0, 255, 0, 255);
			SetEntityRenderFx(entity, RENDERFX_NONE);
			PrintCenterText(activator, "ОТЛИЧНО!");

			if (++g_Unlocked == 3)
			{
				new winner_team = GetClientTeam(activator);
				for (new i = 1; i <= MaxClients; i++)
				{
					if (IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) != winner_team)
						ForcePlayerSuicide(i);
				}
				PrintToChatAll("\x04%N завершил смертельную игру!", activator);
			}
		}
		else
		{
			g_Unlocked = 3;
			ForcePlayerSuicide(activator);
			for (new i = 0; i < 3; i++)
			{
				if ((entity = EntRefToEntIndex(GetArrayCell(g_hRefs_Array, i))) > 0)
					AcceptEntityInput(entity, "Break");
			}
			ClearArray(g_hRefs_Array);
			if (g_hTimer != INVALID_HANDLE) KillTimer(g_hTimer);
			g_hTimer = CreateTimer(3.0, g_hTimer_CallBack);
			PrintToChat(activator, "\x04%N, вам не повезло =/", activator);
		}
	}
}

wS_SetColor(entity, r, g, b, a)
{
	SetEntityRenderMode(entity, RENDER_TRANSCOLOR);
	SetEntityRenderColor(entity, r, g, b, a);
}

public Action:g_hTimer_CallBack(Handle:timer)
{
	g_hTimer = INVALID_HANDLE;
	wS_RestartGame();
	return Plugin_Stop;
}